<template>
  <div>
    <v-container>
      <p class="display-3 font-weight-light	text-center pa-4">Отзывы</p>
      <div class="row">
        <div class="col-md-12 col-sm-12 col-xs-12">
          <v-card elevation="5" class="service">
            <v-card-title>
              {{ service.title }}
            </v-card-title >
            <v-card-subtitle>
              Средний рейтинг:
              <v-icon
                v-for="n in Math.round(service.middle_rating)"
                :key=n
                class='my-star-gold'
              >
                mdi-star
              </v-icon>
              <v-icon
                v-for="n in (5 - Math.round(service.middle_rating))"
                :key=n class='my-star-gold'
              >
                mdi-star-outline
              </v-icon>
              <strong>{{ service.middle_rating }}</strong>
            </v-card-subtitle>
            <v-card-text>
              {{ service.description }}
            </v-card-text>
          </v-card>
          <v-divider/>
          <p class="body-1	font-weight-light pt-10">
            <b>{{ service.reviews.length }} отзыва(ов)</b>
          </p>
          <v-list
            three-line="true"
            avatar="true"
          >
            <v-list-item-group color="primary">
              <v-list-item
                v-for="review in service.reviews"
                :key="review.id"
                inactive="true"
              >
                <v-list-item-title review.user>
                  <strong>{{ review.user }}</strong>поставил(а) оценку {{ review.rating }}
                  <v-icon
                    :class="[ review.rating >=3 ? 'my-star-gold' :  'my-star-red' ]"
                  >
                    mdi-star
                  </v-icon>
                </v-list-item-title>
                <v-list-item-subtitle v-text="review.text"/>
                <v-list-item-content>
                  <v-row>
                    <v-list-item-icon
                      v-show="review.user === username"
                      class="btn-comment"
                    >
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-2 btn-edit"
                            dark
                            color="cyan"
                          >
                            <v-icon dark>mdi-pencil</v-icon>
                          </v-btn>
                        </template>
                        Редактировать
                      </v-tooltip>
                    </v-list-item-icon>
                    <v-list-item-icon v-show="review.user === username">
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            @click.prevent="deleteReview(review.id)"
                            v-bind="attrs"
                            v-on="on"
                            small
                            class="mx-2"
                            dark
                            color="red"
                          >
                            <v-icon dark>mdi-minus-circle</v-icon>
                          </v-btn>
                        </template>
                        Удалить
                      </v-tooltip>
                    </v-list-item-icon>
                  </v-row>
                </v-list-item-content>
              </v-list-item>
            </v-list-item-group>
          </v-list>
        </div>
      </div>
      <v-divider/>
      <p v-show='token' class="body-1	font-weight-light pt-12">
        Добавить отзыв
      </p>
      <v-form
        v-show='token'
        @submit.prevent="leaveComment"
      >
        <v-textarea
          v-model='text'
          class="mx-2"
          label="Введите текст"
          rows="1"
          required
          prepend-icon="mdi-comment"
        />
        <v-col
          class="d-flex"
          cols="12"
          sm="2"
        >
          <v-select
            v-model="rating"
            :items="items"
            label="Выберите оценку"
          />
        </v-col>
        <v-btn
          @click.prevent="addReview"
          :type="'submit'"
          color="primary"
        >
          Добавить отзыв
        </v-btn>
      </v-form>
    </v-container>
  </div>
</template>

<script>
import axios from "axios";

export default {
  name: 'Post',
  props: ['id'],
  data() {
    return {
      items: [1, 2, 3, 4, 5],
      text: '',
      rating: '',
      service: {},
    }
  },
  computed: {
    token() {
      return this.$store.getters.getToken
    },
    username() {
      return this.$store.getters.getUsername
    }
  },
  created() {
    this.$setTitle('Отзывы')
    this.loadService()
  },
  methods: {
    async loadService() {
      this.$store.commit('setLoading', true)
      this.service = await axios.get(
        `${this.$store.getters.getServerUrl}api/v1/reviews/services/${this.id}/`
      ).then(response => response.data)
      this.$store.commit('setLoading', false)
    },
    async addReview() {
      await axios({
        method: 'post',
        data: {
          'text': this.text,
          'rating': this.rating,
          'service': this.service.id,
          'user': this.username
        },
        url: `${this.$store.getters.getServerUrl}api/v1/reviews/`,
        headers: { 'Authorization': `JWT ${this.token}` }
      }).then(r => r.data)
      this.text = ''
      this.service = ''
      this.loadService()
    },
    async deleteReview(arg) {
      await axios({
        method: 'delete',
        url: `${this.$store.getters.getServerUrl}api/v1/reviews/${arg}/`,
        headers: { 'Authorization': `JWT ${this.token}` }
      })
      this.loadService()
    }
  }
}
</script>

<style scoped>
.my-star-gold {
  color:gold;
  font-size: 30px;
}
.my-star-red {
  color:red;
  font-size: 30px;
}
.service {
  margin: 50px 0px 0px 0px;
}
</style>
